package query


#######################################################################
# Macros whose values are set from within the server at runtime. These 
# are here only for reference and to set default values if required.           
#######################################################################

_quotedquery_ {}
_freqmsg_ {}
_resultline_ {}
_thisfirst_ {}
_thislast_ {}
_nextfirst_ {}
_nextlast_ {}
_prevfirst_ {}
_prevlast_ {}
_searchhistorylist_ {}
#_histvalue0_ to _histvalue19_
_advformlist_ {}
_regformlist_ {}
_fqfselection_ {}


#######################################################################
# icons
#######################################################################

_iconthispage_ {<img src="_httpiconhsearch_" alt="_texticonthispage_" width="_widthhsearch_" height="_heighthsearch_">}
_iconthispage_ [v=1] {<h2>_texticonthispage_</h2>}

_iconqueryresultsbar_ {<img src="_httpiconqryresb_" width="_widthqryresb_" height="_heightqryresb_" alt="_texticonqueryresultsbar_">}
_iconqueryresultsbar_[v=1] {_texticonqueryresultsbar_}

_iconsearchhistorybar_ {<img src="_httpiconsrchhistb_" width="_widthsrchhistb_" height="_heightsrchhistb_" alt="_texticonsearchhistorybar_">}
_iconsearchhistorybar_[v=1] {_texticonsearchhistorybar_}

# _iconnext_ and _iconprev_ are overridden in this package as we
# don't want alt text here
_iconnext_{<img src="_httpiconmore_" width=_widthmore_ height=_heightmore_ border=0 align=top>}
_iconnext_ [v=1] {}
_iconprev_{<img src="_httpiconless_" width=_widthless_ height=_heightless_ border=0 align=top>}
_iconprev_ [v=1] {}

# the small squares for search history
## " " ## handmade ## mstds ##
_httpiconmstdsqrof_ {_httpimg_/mstdsof.gif}
_httpiconmstdsqron_ {_httpimg_/mstdson.gif}
_widthmstdsqrx_ {13}
_heightmstdsqrx_ {13}

#######################################################################
# images
#######################################################################

_imagethispage_ {_iconthispage_}

#the buttons for the search history entries
# takes one arg - the entry number (0-num entries)
_imagehistbutton_ {<a  href="_httpquery_" onMouseover="roll('histbutton_1_',1);" onMouseOut="roll('histbutton_1_',0);" onClick="inputQuery(histvalue_1_); return false;"><img name="histbutton_1_" src="_httpiconmstdsqrof_" onLoad="gbutton(this,'_httpiconmstdsqron_');" border=0 alt="_textusequery_"></a>}


#######################################################################
# scripts (and some macros for the scripts)
#######################################################################

_pagescriptextra_ {_If_("_cgiargct_" eq "1" && "_cgiargqt_" eq "1",_formpagescriptextra_,_dummypagescriptextra_)
_If_("_cgiarghd_" ne "0",_historypagescriptextra_) }

_dummypagescriptextra_{
function initialize() \{
\}
}
_formpagescriptextra_ {
// query scripts generated by \_query:pagescriptextra\_

_standardfunctions_
_formfunctions_
_searchfunctions_

function getsearchargs () \{

  var args="";
  args = "&fqa=0&fqv="+argfqv+"&fqf="+argfqf;
  _If_(_cgiargb_,args += "&fqk="+argfqk+"&fqs="+argfqs+"&fqc="+argfqc;)

  return args;
\}



function getqueryargs () \{
  return "&fqa=1"+"&q="+argq+"&fqv="+argfqv+"&fqf="+argfqf+
	 "&fqk="+argfqk+"&fqs="+argfqs+"&fqc="+argfqc ;
\}

}

_historypagescriptextra_{

var histvalue0='_histvalue0_';
var histvalue1='_histvalue1_';
var histvalue2='_histvalue2_';
var histvalue3='_histvalue3_';
var histvalue4='_histvalue4_';
var histvalue5='_histvalue5_';
var histvalue6='_histvalue6_';
var histvalue7='_histvalue7_';
var histvalue8='_histvalue8_';
var histvalue9='_histvalue9_';
var histvalue10='_histvalue10_';
var histvalue11='_histvalue11_';
var histvalue12='_histvalue12_';
var histvalue13='_histvalue13_';
var histvalue14='_histvalue14_';
var histvalue15='_histvalue15_';
var histvalue16='_histvalue16_';
var histvalue17='_histvalue17_';
var histvalue18='_histvalue18_';
var histvalue19='_histvalue19_';

function inputQuery(value) \{
  if ("_cgiargqt_" == "0") \{ // text search
     document.QueryForm.q.value += " "+value;
  \}
  else \{
     if ("_cgiargb_" == "1") \{ // advanced query
        document.QueryForm.q.value += " "+value;
	updateq();
     \}
     else \{ // simple form search
	  // do something here, what??
     \}
  \}
\}

}

_standardfunctions_{

 function getstdargs() \{
    
    stdarg = "";
    _If_(_cgiargh_,_getharg_)
    _If_(_gselection_,_getgarg_)	
    _If_(_cgiargj_,_getjarg_)

    value = document.QueryForm.t.options[document.QueryForm.t.selectedIndex].value;
    if (value != "_cgiargt_") stdarg += "&t="+value;

    stdarg += "&r=1&hs=1";    
    return stdarg;
  \}

}

#some macros to go with getstdargs()
_getharg_{
    value = document.QueryForm.h.options[document.QueryForm.h.selectedIndex].value;
    if (value != "_cgiargh_") stdarg += "&h="+value;
}

_getgarg_{
    value = document.QueryForm.g.options[document.QueryForm.g.selectedIndex].value;
    if (value != "_cgiargg_") stdarg += "&g="+value;
}

_getjarg_{
    value = document.QueryForm.j.options[document.QueryForm.j.selectedIndex].value;
    if (value != "_cgiargj_") stdarg += "&j="+value;
}


_formfunctions_{

argfqf="_cgiargfqf_";	
argfqv="_cgiargfqv_";
argfqk="_cgiargfqk_";
argfqs="_cgiargfqs_";
argfqc="_cgiargfqc_";
argq = "";

function initialize () \{

   if (document.QueryForm.fqf != null) \{initfqf();\}
   initfqv();
   if ( "_cgiargb_" == "1") \{
      initfqs();	    
      initfqk();
      initfqc();
      initq();
   \}
   
\}

// fqf - the field selection box
function initfqf() \{
   var i;
   fqf = argfqf.split(",");   
   for (i=0; i<fqf.length; i++) \{
       for (j=0;j<document.QueryForm.fqf[i].options.length;j++) \{
	   if (fqf[i] != "" && fqf[i]== document.QueryForm.fqf[i].options[j].value) \{
	      document.QueryForm.fqf[i].options[j].selected = true;
	      break;	
	   \}
	\}
   \}
   if (fqf.length < document.QueryForm.fqf.length) \{ // initialize remaining ones
      var v=1; // the option with a null value is either at place 1 or 2
      if (document.QueryForm.fqf[0].options[v].value !="") v++;
      for (i=fqf.length;i<document.QueryForm.fqf.length;i++) \{
	  var z=i;
	  while (z >= document.QueryForm.fqf[i].options.length-1) \{
	     z = z-(document.QueryForm.fqf[i].options.length-1);
	  \}
	  if (z>=v)z++; // skip over the void value
	  
	  document.QueryForm.fqf[i].options[z].selected = true;
	  
      \}
   \}
   updatefqf();

\}

function updatefqf() \{

   var i;
   argfqf = "";
   var j = document.QueryForm.fqf[0].selectedIndex;
   argfqf += document.QueryForm.fqf[0].options[j].value;
   for (i=1; i<document.QueryForm.fqf.length;i++) \{
      j = document.QueryForm.fqf[i].selectedIndex;
      argfqf += "," + document.QueryForm.fqf[i].options[j].value;
   \}

\}


function clearfqf() \{
   var i;
   for (i=0;i<document.QueryForm.fqf.length;i++) \{
       var z = i;
       if (i >= document.QueryForm.fqf[i].options.length) z = z-document.QueryForm.fqf[i].options.length;
       document.QueryForm.fqf[i].options[z].selected = true;
   \}
   updatefqf();
\}

// fqc - the boolean operator selection box
function initfqc() \{
   var i,j;
   fqc = argfqc.split(",");
   if (_cgiargfqn_ == 2) \{ // there will only be one fqc element
       for (j=0;j<document.QueryForm.fqc.options.length;j++) \{
	   if (fqc[0] == document.QueryForm.fqc.options[j].value) \{
	      document.QueryForm.fqc.options[j].selected = true;
	      break;
	   \}
       \}   
   \}
   else \{   
   for (i=0; i<fqc.length;i++) \{
       for (j=0;j<document.QueryForm.fqc[i].options.length;j++) \{
	   if (fqc[i] == document.QueryForm.fqc[i].options[j].value) \{
	      document.QueryForm.fqc[i].options[j].selected = true;
	      break;
	   \}
       \}
   \}
   \}
   updatefqc();

\}

function updatefqc() \{
  
   var i,j;
   argfqc = "";
   if (_cgiargfqn_ == 2) \{
      j = document.QueryForm.fqc.selectedIndex;
      argfqc += document.QueryForm.fqc.options[j].value;
   \}
   else \{
	j = document.QueryForm.fqc[0].selectedIndex;
	argfqc += document.QueryForm.fqc[0].options[j].value;
	for (i=1;i<document.QueryForm.fqc.length;i++) \{
	    j = document.QueryForm.fqc[i].selectedIndex;
	    argfqc += "," + document.QueryForm.fqc[i].options[j].value;
	\}
   \}

\}


function clearfqc() \{
   
   var i;
   if (_cgiargfqn_ == 2) \{
       document.QueryForm.fqc.options[0].selected = true;
   \}
   else \{
	for (i=0; i<document.QueryForm.fqc.length; i++) \{
	    document.QueryForm.fqc[i].options[0].selected = true;
	\}
   \}
   updatefqc();
\}

// fqv - the query word/phrase text box       
function initfqv() \{

   var i;
   fqv= argfqv.split(",");
   for (i=0; i<fqv.length; i++) \{
       document.QueryForm.fqv[i].value = fqv[i];
   \}
   updatefqv();


\}


function updatefqv() \{

   var i;
   argfqv="";
   argfqv += escape(format(document.QueryForm.fqv[0].value));
   for (i=1; i<document.QueryForm.fqv.length;i++) \{
       argfqv += ",";
       argfqv +=  escape(format(document.QueryForm.fqv[i].value)); 
   \}
\}

function clearfqv() \{
   var i;
   for (i=0; i< document.QueryForm.fqv.length;i++) \{
       document.QueryForm.fqv[i].value = "";
   \}
   updatefqv();
\}

// fqs - the stemming checkboxes
function initfqs() \{

   var i;
   fqs = argfqs.split(",");
   for (i=0; i<fqs.length; i++) \{
       if (fqs[i]=="1") \{
	  document.QueryForm.fqs[i].checked = true;
       \}
   \}
   updatefqs();

\}

function updatefqs() \{
   argfqs="";
   if (document.QueryForm.fqs[0].checked) \{
      argfqs += "1";
   \}
   else \{
      argfqs += "0";	
   \}
   var i;
   for (i=1; i<document.QueryForm.fqs.length; i++) \{
       if (document.QueryForm.fqs[i].checked) \{
	  argfqs += ",1";
	\}
	else \{
	  argfqs += ",0";
	\}
   \}
\}


function clearfqs() \{
   var i;
   for (i=0; i<document.QueryForm.fqs.length; i++) \{
       document.QueryForm.fqs[i].checked = false;
   \}
   updatefqs();
\}

// kqk - the casefolding checkboxes
function initfqk() \{
   var i;
   fqk = argfqk.split(",");
   for (i=0; i<fqk.length; i++) \{
       if (fqk[i]=="1") \{
	  document.QueryForm.fqk[i].checked = true;
       \}
   \}
   updatefqk();

\}


function updatefqk() \{
   argfqk="";
   if (document.QueryForm.fqk[0].checked) \{
      argfqk += "1";
   \}
   else \{
      argfqk += "0";	
   \}
   var i;
   for (i=1; i<document.QueryForm.fqk.length; i++) \{
       if (document.QueryForm.fqk[i].checked) \{
	  argfqk += ",1";
	\}
	else \{
	  argfqk += ",0";
	\}
   \}
\}

function clearfqk() \{
   var i;
   for (i=0; i<document.QueryForm.fqk.length; i++) \{
       document.QueryForm.fqk[i].checked = false;
   \}
   updatefqk();
\}

// q - the advanced query box
function initq() \{
   updateq();
\}

function updateq() \{
   argq = "";
   argq += escape(document.QueryForm.q.value);
\}

function clearq() \{
   document.QueryForm.q.value="";
\}


// convert commas and spaces to plus
function format(string) \{
   var str = "" + string;
   var out = "", flag = 0;
   var j;
   for (j = 0; j < str.length; j++) \{
       if (str.charAt(j) == " "|| str.charAt(j) == ",") \{
       if ( flag == 0) \{
	  out += "+";
	  flag=1;
	  \}
	\}
       else \{
          out += str.charAt(j);
	  flag=0;
       \}
   \}
   return out;
\}

}

#_httpquery_ has a=q&e=compressedargs
#if adv form, need to set k=0 and s=0
_advformargs_{_If_(_cgiargb_,&k=0&s=0)}

_searchfunctions_ {

function beginSearch() \{
window.location="_httpquery_"+getstdargs()+"_advformargs_"+getsearchargs();
\}

function runQuery() \{
window.location="_httpquery_"+getstdargs()+"_advformargs_"+getqueryargs();
\}

function clearForm() \{
   clearfqf();
   clearfqv();

   if ("_cgiargb_" == "1") \{
      clearfqk();
      clearfqs();
      clearfqc();
   \}

\}

}

#######################################################################
# headers
# these are overridden so we can put an onLoad event handler
# in the <body> tag of this page - for mgpp, form search pages
#######################################################################

#copied from prefs 

_header_ {_cgihead_
_htmlhead_(background="_httpiconchalk_" onLoad="initialize();")_startspacer__pagebanner_
}

# this declaration ends up being the same as style=restrict, never mind
_header_[v=1] {_cgihead_
_htmlhead_(onLoad="initialize();")_pagebanner_
}

#######################################################################
# page content
#######################################################################


_pagetitle_ {_If_(_cgiargq_,_textquerytitle_,_textnoquerytitle_)}


_content_ {
<center>
_navigationbar_
</center>
<center>
_If_(_cgiargct_,_selectqueryform_,_queryform_)
</center>
_If_(_searchhistorylist_,<center>_iconsearchhistorybar_</center><br>
<center>
_searchhistorylist_
</center>)
_If_(_cgiargq_,<center>_iconqueryresultsbar_</center><br>
<small>
_freqmsg_
_textpostprocess_</small><br>
_resultline_
,<center>_iconblankbar_</center>)<br>
}

_selectqueryform_{_If_(_cgiargqt_,_fieldqueryform_,_queryform_)}

_queryform_ {
<!-- query form (\_query:queryform\_) -->
<form name=QueryForm method=get action="_gwcgi_">

<input type=hidden name="a" value="q">
<input type=hidden name="r" value="1">
<input type=hidden name="hs" value="1">
<input type=hidden name="e" value="_decodedcompressedoptions_">
_queryformcontent_

</form>
<!-- end of query form -->
}

_queryformcontent_{_basicqueryform_}

_basicqueryform_ {<table><tr><td>
<nobr>_textselect_</nobr>
</td></tr>
<tr><td>
_If_(_cgiargqb_,_largequerybox_,_smallquerybox_)
</td></tr></table>
}

_datesearch_
{<table><tr><td>
	<center>
_textstartdate_
<input type="text" name="ds" value = "_cgiargds_"size="4" maxlength="4">
<select name="dsbc" value="_cgiargdsbc_" size="1">
	<option value = "0"_If_(_cgiargdsbc_,, selected)>_textad_
	<option value = "1"_If_(_cgiargdsbc_, selected)>_textbc_
</select> 
_textenddate_
<input type="text" name="de" value = "_cgiargde_" size="4" maxlength="4"> 
<select name="debc" size="1">
	<option value = "0" _If_(_cgiargdebc_,, selected)>_textad_
	<option value = "1" _If_(_cgiargdebc_, selected)>_textbc_
</select> 
</center>	  
</tr></td>
<tr><td>
_textexplaineras_
</tr></td>
</table>
</center>
}

_smallquerybox_ {<tr><td><nobr><input type="text" name="q" value="_cgiargq_" size="50">
<input type="submit" value="_textbeginsearch_"></nobr>}

_largequerybox_ {
<tr><td><textarea name="q" cols=63 rows=10>
_cgiargq_
</textarea></td></tr>
<tr align=right><td><table>
<tr><td><input type="submit" value="_textbeginsearch_"></td>
</tr></table></td></tr>}


_fieldqueryform_ {
<!-- field query form (\_query:fieldqueryform\_) -->
<form name=QueryForm method=get action="_gwcgi_">
<table><tr><td>
<nobr>
_textformselect_
</nobr>
</td></tr>
_If_(_cgiargb_,_advancedforms_,_simpleforms_)
</table>
_If_(_cgiargb_,<center>_iconblankbar_</center><br>
<center>_advancedformextra_</center>)
</form>
<!-- end of query form -->
}

_advancedforms_{
<tr><td><center> <table border=0 cellspacing=0 cellpadding=0 width="90%">
<tr><th></th><th align=left>_textwordphrase_</th><th colspan=2><nobr>_textfoldstem_</nobr></th><th align=center>&nbsp;&nbsp;_textinfield_</th></tr>	
_advformlist_
<tr><td colspan=2><input type=button value="_textclearform_" onClick="clearForm();"></td>
<td colspan=3><table>
<tr><td><input type=button value="_textbeginsearch_" onClick="beginSearch();"></td>
</tr></table></td></tr>
</table></td></tr>
}

_advancedformextra_{
<table>
<tr><td>_textadvquery_</td></tr>
<tr><td><textarea name=q cols=57 rows=3 onChange="updateq();">_cgiargq_</textarea></td>
<td valign=bottom>
<input type="button" value="_textrunquery_" onClick="runQuery();"></td></tr>
</table>
}

_simpleforms_{
<tr><td><center> <table border=0 cellspacing=0 cellpadding=0 width="90%">
<tr><th align=left>_textwordphrase_</th><th align=left>&nbsp;&nbsp;_textinfield_</th></tr>	
_regformlist_
<tr><td><input type=button value="_textclearform_" onClick="clearForm();"></td>
<td><table>
<tr><td><input type=button value="_textbeginsearch_" onClick="beginSearch();"></td>
</tr>
</table></td></tr>
</table></td></tr>}

_regformelement_{
<td><input type=text size=39 name="fqv" onChange="updatefqv();"></td>
<td>_fqfselection_</td>}

#has no and/or/not selection box
_firstadvformelement_{
<td></td><td><input type=text size=31 name="fqv" onChange="updatefqv();"></td>
<td align=center><input type=checkbox name="fqk" onClick="updatefqk();""></td>
<td align-center><input type=checkbox name="fqs" onClick="updatefqs();"></td>
<td align=right>_fqfselection_</td>}

_advformelement_{
<td>_fqcselection_</td>
<td><input type=text size=31 name="fqv" onChange="updatefqv();"></td>
<td align=center><input type=checkbox name="fqk" onClick="updatefqk();"></td>
<td align-center><input type=checkbox name="fqs" onClick="updatefqs();"></td>
<td align=right>_fqfselection_</td>}

_fqcselection_ {
<select name="fqc" onChange="updatefqc();">
<option value="and">_textand_
<option value="or">_textor_
<option value="not">_textandnot_
</select>}

_textselect_ {_If_(_cgiargb_,_textadvancedsearch_,_textsimplesearch_)}
_textformselect_ {_If_(_cgiargb_,_textformadvancedsearch_,_textformsimplesearch_)}

_ZZ_{_textallfields_}

# we want to put the links to previous/next pages of results
# in the footer
_pagefooterextra_ {
<center>
<table cellspacing=0 cellpadding=0 width=_pagewidth_>
<tr>
<td align=left>_If_(_prevfirst_,<a href="_httpquery_&r=_prevfirst_">_iconprev__textmatches__prevfirst_ - _prevlast_</a>)</td>
<td align=right>_If_(_nextfirst_,<a href="_httpquery_&r=_nextfirst_">_textmatches__nextfirst_ - _nextlast__iconnext_</a>)</td>
</tr></table>
</center>
}

_querytypeselection_ {
<select name="t">
<option value="1"_If_(_cgiargt_, selected)>_textsome_
<option value="0"_If_(_cgiargt_,, selected)>_textall_
</select>
}

_formquerytypeselection_ {
<select name="t">
<option value="1"_If_(_cgiargt_, selected)>_textformsome_
<option value="0"_If_(_cgiargt_,, selected)>_textformall_
</select>
}


